#ifndef lint
static char *RCSid = "$Header: /users/empire/EMP/empmain/common/RCS/xy.c,v 1.8 89/07/01 14:37:54 mr-frog Exp $";
#endif

/*
**  loc.c
**
**  Location and vehicle description print routines
**
*/

#include <ctype.h>
#include "misc.h"
#include "sect.h"
#include "ship.h"
#include "spy.h"
#include "file.h"
#include "xy.h"
#include "plane.h"
#include "loc.h"
#include "nat.h"
#include <stdio.h>

char *spyasc(spy,prep,who)
struct spystr *spy;
int prep;
natid who;
{
    static char buf[2][20];
    static int nbuf = 1;
    char namebuf[40];
    nbuf = 1-nbuf;
    sprintf(namebuf,"%s (#%d)",cname(spy->spy_own),spy->spy_own);
    sprintf(buf[nbuf],"%s%s%s #%d%s%s%s%s%s",
	    prep&LO ? namebuf : "",
	    prep&LO ? " " : "",
	    spchr[spy->spy_type].sp_name,spy->spy_uid,
	    *(spy->spy_name) ? " (" : "",
	    spy->spy_name,
	    *(spy->spy_name) ? ")" : "",
	    prep&LS ? " @ " : "",
	    prep&LS ? xyas(spy->spy_x,spy->spy_y,who) : "");
    return buf[nbuf];
}

char *spyas(spy,prep)
struct spystr *spy;
int prep;
{
    return spyasc(spy,prep,cnum);
}

char *planeasc(plane,prep,who)
struct plnstr *plane;
int prep;
natid who;
{
    static char buf[2][40];
    static int nbuf = 1;
    char namebuf[40];
    nbuf = 1-nbuf;
    sprintf(namebuf,"%s (#%d)",cname(plane->pln_own),plane->pln_own);
    sprintf(buf[nbuf],"%s%s%s (#%d)%s%s",
	    prep&LO ? namebuf : "",
	    prep&LO ? " " : "",
	    plchr[plane->pln_type].pl_name,
	    plane->pln_uid,
	    prep&LS ? " @ " : "",
	    prep&LS ? xyas(plane->pln_x,plane->pln_y,who) : "");
    return buf[nbuf];
}

char *planeas(plane,prep)
struct plnstr *plane;
int prep;
{
    return planeasc(plane,prep,cnum);
}

char *shipasc(ship,prep,who)
struct shpstr *ship;
int prep;
natid who;
{
    static char buf[2][40];
    static int nbuf = 1;
    char namebuf[40];
    nbuf = 1-nbuf;
    sprintf(namebuf,"%s (#%d)",cname(ship->shp_own),ship->shp_own);
    sprintf(buf[nbuf],"%s%s%s%s #%d%s%s%s%s%s",
	    prep&LP ? "aboard " : "",
	    prep&LO ? namebuf : "",
	    prep&LO ? " " : "",
	    mchr[ship->shp_type].m_name,ship->shp_uid,
	    *(ship->shp_name) ? " (" : "",
	    ship->shp_name,
	    *(ship->shp_name) ? ")" : "",
	    prep&LS ? " @ " : "",
	    prep&LS ? xyas(ship->shp_x,ship->shp_y,who) : "");
    return buf[nbuf];
}

char *shipas(ship,prep)
struct shpstr *ship;
int prep;
{
    return shipasc(ship,prep,cnum);
}

char *sectasc(sect,prep,who)
struct sctstr *sect;
int prep;
natid who;
{
    static char buf[2][40];
    static int nbuf = 1;
    char namebuf[40];
    nbuf = 1-nbuf;
    sprintf(namebuf,"%s (#%d)",cname(sect->sct_own),sect->sct_own);
    sprintf(buf[nbuf],"%s%s%s%s%s%s",
	    prep&LP ? "in " : "",
	    prep&LO ? namebuf : "",
	    prep&LO ? " " : "",
	    dchr[sect->sct_type].d_name,
	    prep&LS ? " @ " : "",
	    prep&LS ? xyas(sect->sct_x,sect->sct_y,who) : "");
    return buf[nbuf];
}

char *sectas(sect,prep)
struct sctstr *sect;
int prep;
{
    return sectasc(sect,prep,cnum);
}

char *locasc(loc,loctype,prep,who)
int loctype,prep;
char *loc;
natid who;
{
    if (loctype==EF_SHIP) return shipasc(loc,prep,who);
    else return sectasc(loc,prep,who);
}

char *locas(loc,loctype,prep)
int loctype,prep;
char *loc;
{
    return locasc(loc,loctype,prep,cnum);
}

char *amtas(amt)
int amt;
{
    if (amt>50) return("lots of ");
    else if (amt>20) return("");
    else if (amt>10) return("some ");
    else if (amt>0) return("a few ");
    else return("no ");
}
