.TH Command STRAFE
.SY "strafe <PLANES> <SECT> <FLIGHTPATH>"
The strafe command lets you use intercept and other non-bomber
aircraft in strafing raids against the populace, vessels, planes, 
or vehicles in a specific sector.  As strafing raids use no heavy
artillery, no guns or shells are required.
.s3
Each plane in the raid is generally able to make multiple 
strafing passes once the target sector is reached.  The number
of passes a plane can make is equal to the plane's bomb load
capability.  All planes involved in the attack make each pass as
a group going after a specific type of target; you specify the
target type (ship, tank, train, balloon, plane, or populace) at 
the start of each pass.  Once the pass is underway, you will be
prompted to specify a more specific target for each plane that 
is able to shoot.
.s3
Strafing of populace is usually not extremely accurate.
Although you specify whether to exclusively strafe mil, civs, 
or uws, there is always a good chance that your pilots will screw 
up and kill a few innocent bystanders.  (Think twice before
using `\*Qstrafe\*U' to kill civs in a newly conquered but
still uncontrolled sector; you may kill some of your own military.)
.s3
On the other hand, strafing is a very effective way to put an end
to unwanted overflights by foreign balloons.
.s3
Here is a sample strafing run:
.NF

  [152:251] Command : strafe 25 . -28,50
  assembly point @ -24,44
  -24,44 to -28,50: nbbbbb
  <6: -28,50> h
  target sector is -28,50
  range to target is 7
  (#25) jet fighter 1 standing by
  (#25) jet fighter 1 equipped and airborne
  flying over mountain at -23,45
  flying over highway at -24,46
  flying over highway at -25,47
  flying over highway at -26,48
  flying over highway at -27,49
  flying over highway at -28,50
  Target sector is a completely constructed highway:
  
  Coming in for first pass...
  Strafe what (ship, tank, train, balloon, plane, populous, quit)? pop
    many civs
  jet fighter 1 (#25); strafe who (`?' to list, `d' to defer)? c
  !! rat-a-tat-a-tat-a-tat !!!!!!!!!!
  estimated casualties: 46
  
  Coming around for pass #2...
  Strafe what (ship, tank, train, balloon, plane, populous, quit)? pop
    some civs
  jet fighter 1 (#25); strafe who (`?' to list, `d' to defer)? c
  !! rat-a-tat-a-tat-a-tat !!!!!!!!!!!!!!!!!!
  jet fighter 1 (#25) out of ammo
  estimated casualties: 6
  
  Aircraft returning to base

.FI
See also : fly, para, bomb, shoot, populace
