#ifndef lint
static char *RCSid = "$Header: edit.c,v 1.1 89/12/14 08:19:45 jay Exp $";
#endif /* not lint */

/*
 * edit.c
 *
 * David Muir Sharnoff
 *
 * This command NEEDS TO BE REDONE.
 *
 */

#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "nat.h"
#include "news.h"
#include "nsc.h"
#include "item.h"
#include "file.h"
#include "plane.h"
#include "ship.h"
#include "spy.h"
#include "deity.h"

#define END -1
static	prnat();
static	prplane();
static	prship();
static	prsect();
static	noise();
static	benefit();

extern int sect_mob_max;
extern int ship_mob_max;
extern int plane_mob_max;
extern int spy_mob_max;
extern int max_btus;
extern      int m_m_p_d;

nyi() { pr("Not yet implemented\n"); }

/*
 * format: give c <amt> <commod> <sect>
 */
edit()
{
    extern	char *argp[];
    extern	int shp_maxno;
    extern	int m_m_p_d;
    struct	sctstr sect;
    struct	plnstr plane;
    struct	shpstr ship;
    struct	spystr spy;
    char	*msg;
    char	*what;
    char	*ptr;
    char	*thing;
    int	num;
    int	arg;
    int	err;
    int vc;
    coord	x, y;
    float	farg;
    natid	nat;
    struct	natstr	*np;
    
    what = getstarg(argp[1],
        "Edit what (country, land, ship, tank, balloon, train, plane, nuke, spy)? ");
    if (!what || !*what) return RET_SYN;
    vc = -1;
    switch (what[0]) {
    case 'l':
	ptr = getstarg(argp[2],"sector? ");
	if (!ptr) return RET_FAIL;
	if (!sarg_xy(ptr, &x, &y)) return RET_FAIL;
	if (!getsect(x, y, &sect)) return RET_FAIL;
	break;
    case 'c':
	num = natarg(argp[2], "country number? ");
	if (num < 0) return RET_SYN;
	nat = (natid) num;
	np = getnatp(nat);
	break;
    case 'p':
	num = onearg(argp[2],"plane number? ");
	if (num < 0) return RET_SYN;
	if (!getplane(num, &plane)) return RET_SYN;
	break;
    case 'b': vc = CLASS_BALLOON; break;
    case 't': vc = (what[1]=='a') ? CLASS_TANK : CLASS_TRAIN; break;
    case 's': 
	switch (what[1]) {
	case 'p':
	    num = onearg(argp[2],"spy number? ");
	    if (num < 0) return RET_SYN;
	    if (!getspy(num, &spy)) return RET_SYN;
	    break;
	case 'h':
	    vc = CLASS_SHIP;
	}
	break;
    case 'n': nyi(); return RET_FAIL;
    default:  pr("huh?\n"); return RET_SYN;
    }

    if (vc >= 0) {
	num = onearg(argp[2],fmt("%s number? ",class[vc].name));
	if (num < 0) return RET_SYN;
	if (!getship(num, &ship)) return RET_SYN;
	if (vehicleclass(&ship) != vc) {
	    pr(fmt("not a %s\n",class[vc].name));
	    return RET_SYN;
	}
    }

    if (!argp[3]) {
	switch (what[0]) {
	case 'l': prsect(&sect); break;
	case 'c': prnat(nat); break;
	case 'p': prplane(&plane); break;
	case 's': if (what[1]=='p') { prspy(&spy); break; }
	default:  prship(&ship); break;
	}
    } else if (argp[4])
	(void) strcat (argp[3], argp[4]);
    
    if (!(ptr = getstarg(argp[3], "%c xxxxx -- thing value : ")))
	return RET_SYN;
    
    for (;;) {
	switch (what[0]) {
	case 'c':
	    ef_close(EF_NATION);
	    ef_open(EF_NATION,O_RDONLY,EFF_MEM);
	    break;
	case 'l': break;
	case 'p': break;
	default:  break;
	}
	if ((err = getin(&thing, &ptr, &arg)) != RET_OK)
	    if (err != END) return err;
	    else {
		switch (what[0]) {
		case 'c': tm_sync(5000); prnat(nat); break;
		case 'l': prsect(&sect); break;
		case 'p': prplane(&plane); break;
		case 's': if (what[1]=='p') { prspy(&spy); break; }
		default:  prship(&ship); break;
		}
		break;
	    }
	switch (what[0]) {
	case 'c':
	    farg = atof(ptr);
	    if ((err = docountry(thing[0], arg, ptr, farg, nat, np))
		!= RET_OK)
		return err;
	    break;
	case 'l':
	    if ((err = doland(thing[0], arg, &sect)) != RET_OK)
		return err;
	    if (!putsect(&sect))
		return RET_FAIL;
	    break;
	case 'p':
	    if ((err = doplane(thing[0], arg, ptr, &plane))
		!= RET_OK)
		return err;
	    if (!putplane(plane.pln_uid, &plane))
		return RET_FAIL;
	    break;
	case 's':
	    if (what[1]=='p') {
		if ((err = dospy(thing[0], arg, ptr, &spy))!= RET_OK)
		    return err;
		if (!putspy(spy.spy_uid, &spy))
		    return RET_FAIL;
		break;
	    } /* else fall into default */
	default:
	    if ((err = doship(thing[0], arg, ptr, &ship)) != RET_OK)
		return err;
	    if (!putship(ship.shp_uid, &ship))
		return RET_FAIL;
	    break;
	}
	if (err != RET_OK) break;
	else ptr = 0;
    }
    return RET_OK;
}

static benefit(who, good) 
natid who;
int good;
{
    if (good) {
	if (who)
	    nreport(cnum, N_AIDS, who, 1);
    } else {
	if (who)
	    nreport(cnum, N_HURTS, who, 1);
    }
}

static noise(sptr, public_amt, name, old, new)
struct sctstr *sptr;
int public_amt;
char *name;
int old, new;
{
    char p[100];
    pr(fmt("%s of %s changed from %d to %d%\n",
	   name, xyas(sptr->sct_x, sptr->sct_y, cnum), old, new));
    if (public_amt) 
	(void) strcpy(p, fmt("changed from %d to %d", old, new));
    else
	(void) strcpy(p, fmt("%s", old<new ? "increased":"decreased"));
    if (sptr->sct_own)
	wu(0, sptr->sct_own,
	   fmt("%s in %s was %s by an act of %s\n",
	       name, xyas(sptr->sct_x, sptr->sct_y, sptr->sct_own),
	       p, cname(cnum)));
    benefit(sptr->sct_own, (old < new));
}

static prspy(spy)
struct spystr *spy;
{
    pr(fmt("Owner  <o>: %d\t\t", (int)spy->spy_own));
    pr(fmt("Loc    <l>: %s\n", xyas(spy->spy_x, spy->spy_y, cnum)));
    pr(fmt("Effic  <e>: %d\t\t", (int)spy->spy_effic));
    pr(fmt("Mobil  <m>: %d\n", (int)spy->spy_mobil));
    pr(fmt("Ship   <s>: %d\n", spy->spy_ship));
    pr(fmt("Pilot  <p>: %d\n", spy->spy_plntech));
    pr(fmt("Tech   <T>: %d\t\t", spy->spy_tech));
    pr(fmt("Age    <A>: %d\n", spy->spy_age));
    pr(fmt("Educ   <E>: %d\t\t", spy->spy_edu));
    pr(fmt("Happ   <H>: %d\n", spy->spy_hap));
    pr(fmt("OldOwn <O>: %d\t\t", (int)spy->spy_oldown));
    pr("\n");
}

static prsect(sect) 
struct sctstr *sect;
{
/*      ----,----.--.---.---.---.---.---.---.---.---.---.---.---.---.--- */
    pr("  sect       own  oo eff mob min gld frt oil urn wrk lty\n");
    pr("               o   O   e   m   i   g   f   c   u   w   l\n");
    pr(xyfmt("%4d,%-4d", sect->sct_x, sect->sct_y, cnum));
    pr(fmt(" %c%c %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d\n",
	   dchr[sect->sct_type].d_mnem,
	   (sect->sct_newtype == sect->sct_type) ? ' ' :
	   dchr[sect->sct_newtype].d_mnem,
	   sect->sct_own, sect->sct_oldown,
	   sect->sct_effic, sect->sct_mobil,
	   sect->sct_min, sect->sct_gmin,
	   sect->sct_fertil, sect->sct_oil, sect->sct_uran,
	   sect->sct_work, sect->sct_loyal));
    
    pr("             che plg ptime avail bunk\n");
    pr("               x   p     t     a    b\n");
    pr(fmt("            %4d %3d %5d %5d %4d\n",
	   getvar(V_CHE, (char *)sect, EF_SECTOR),
	   getvar(V_PSTAGE, (char *)sect, EF_SECTOR),
	   getvar(V_PTIME, (char *)sect, EF_SECTOR),
	   sect->sct_avail, sect->sct_harden));
}

static prnat(n) 
natid n;
{
    struct natstr *np;
    if ((np = getnatp(n)) == 0)	return;
    pr(fmt("Country #: %2d\n", n));
    pr(fmt("Name <n>: %-20s\t", np->nat_cnam)); 
    pr(fmt("Representative <r>: %-20s\n", np->nat_pnam));
    pr(fmt("BTUs <b>: %3d\t\t\t", np->nat_btu));
    pr(fmt("Reserves <m>: %5d\n", np->nat_reserve));
    pr(fmt("Capital <c>: %s\t\t", xyas(np->nat_xcap, np->nat_ycap, cnum)));
    pr(fmt("Origin <o>: %3s\n", xyas(np->nat_xorg, np->nat_yorg, cnum)));
    pr(fmt("Status <s>: 0x%x\t\t\t", np->nat_stat));
    pr(fmt("Min Used <u>: %3d\n", np->nat_minused));
    pr(fmt("Technology <T>: %.2f\t\t", np->nat_level[NAT_TLEV]));
    pr(fmt("Research <R>: %.2f\n", np->nat_level[NAT_RLEV]));
    pr(fmt("Education <E>: %.2f\t\t", np->nat_level[NAT_ELEV]));
    pr(fmt("Happiness <H>: %.2f\n", np->nat_level[NAT_HLEV]));
    pr(fmt("Money <M>: $%6d\t\t", np->nat_money));
    pr(fmt("Logged in <L>: %d\n",np->nat_login));
    pr("Status bit definitions:\n");
    pr("   1=inuse   2=sanc   4=norm   8=god\n");
    pr("  16=abs    32=new   64=cap  128=money\n");
}

static prplane(plane)
struct plnstr *plane;
{
    pr(fmt("Owner <o>: %d\t\t", (int)plane->pln_own));
    pr(fmt("Location <l>: %s\n", xyas(plane->pln_x, plane->pln_y, cnum)));
    pr(fmt("Efficiency <e>: %d\t", (int)plane->pln_effic));
    pr(fmt("Mobility <m>: %d\n", (int)plane->pln_mobil));
    pr(fmt("Tech <t>: %d\t\t", plane->pln_tech));
    pr(fmt("Wing <w>: %c\n", plane->pln_wing));
    pr(fmt("Attack <a>: %d\t\t", plane->pln_att));
    pr(fmt("Defense <d>: %d\n", plane->pln_def));
    pr(fmt("Range <r>: %d\n", plane->pln_range));
    pr(fmt("Ship <s>: %d\n", plane->pln_ship));
}

static prship(ship)
struct shpstr *ship;
{
    int	vec[I_MAX+1];
    struct natstr *natp;
    if ((natp = getnatp(ship->shp_own)) == 0) return;
    pr(fmt("%s (#%d) %s #%d\n", natp->nat_cnam, (int)ship->shp_own,
	   mchr[ship->shp_type].m_name, ship->shp_uid));
    pr(fmt("ID <I>: %d\n", (int)ship->shp_uid));
    pr(fmt("Owner <O>: %d\t\t\t", (int)ship->shp_own));
    pr(fmt("Location <L>: %s\n", xyas(ship->shp_x, ship->shp_y, cnum)));
    pr(fmt("Tech <T>: %d\t\t\t", ship->shp_tech));
    pr(fmt("Efficiency <E>: %d\n", (int)ship->shp_effic));
    pr(fmt("Mobility <M>: %d\t\t", (int)ship->shp_mobil));
    pr(fmt("Fleet <F>: %c\n", ship->shp_fleet));
    pr(fmt("Planes <P>: %d\t\t", (int)ship->shp_nplane));
    pr(fmt("Tanks <N>: %d\n", (int)ship->shp_ntank));
    pr(fmt("Depth <D>: %d\t\t",(int)ship->shp_depth));
    pr(fmt("Aboard <A>: %d\n",(int)ship->shp_aboard));
    pr(fmt("Convoy <C>: %c\t\t", ship->shp_convoy));
    pr(fmt("Oxygen <X>: %d\n",(int)ship->shp_air));
    getvec(VT_ITEM, vec, (char *)ship, EF_SHIP);
    pr("civ mil  uw food shl gun  pet  irn  dst  oil  lcm  hcm rad\n");
    pr("  c   m   u    f   s   g    p    i    d    o    l    h   r\n");
    pr(fmt("%3d", vec[I_CIVIL]));
    pr(fmt("%4d", vec[I_MILIT]));
    pr(fmt("%4d", vec[I_UW]));
    pr(fmt("%5d", vec[I_FOOD]));
    pr(fmt("%4d", vec[I_SHELL]));
    pr(fmt("%4d", vec[I_GUN]));
    pr(fmt("%5d", vec[I_PETROL]));
    pr(fmt("%5d", vec[I_IRON]));
    pr(fmt("%5d", vec[I_DUST]));
    pr(fmt("%5d", vec[I_OIL]));
    pr(fmt("%5d", vec[I_LCM]));
    pr(fmt("%5d", vec[I_HCM]));
    pr(fmt("%4d", vec[I_RAD]));
    pr("\n");
}

restrict(min,num,max)
int min,num,max;
{
    if (num < min) {
	pr(fmt("Using minimum allowable value (%d)\n",min));
	num = min;
    } else if (num > max) {
	pr(fmt("Using maximum allowable value (%d)\n",max));
	num = max;
    }
    return(num);
}

errcheck(num, max)
int num, max;
{
    return(restrict(0,num,max));
}

getin(what, p, arg)
char **what, **p;
int *arg;
{
    *what = getstarg(*p, "%c xxxxx -- thing value : ");
    if (!*what) return RET_SYN;
    if (!**what) return END;
    while (**what && **what<=' ') what++;
    *p = *what + 1;
    while(**p && **p<=' ') (*p)++;
    *arg = atoi(*p);
    /*	if (*arg < 0) *arg = 0; */
    return RET_OK;
}


doland(op, arg, sect)
char op;
int arg;
struct	sctstr *sect;
{
    natid	newown, oldown;
    int	new, old;
    switch (op) {
    case 'o':
	if (arg < 0)
	    return RET_SYN;
	newown = (natid) errcheck(arg, MAXNOC-1);
	pr(fmt("Owner of %s changed from %s (#%d) to %s (#%d).\n",
	       xyas(sect->sct_x, sect->sct_y, cnum),
	       cname(sect->sct_own),
	       sect->sct_own, cname(newown), newown));
	if (sect->sct_own) {
	    wu(0, sect->sct_own, 
	       fmt("Sector %s lost to deity intervention", 
		   xyas(sect->sct_x, sect->sct_y, sect->sct_own)));
	}
	benefit(sect->sct_own, 0);
	sect->sct_own = newown;
	if (newown) {
	    wu(0, newown,
	       fmt("Sector %s gained from deity intervention",
		   xyas(sect->sct_x, sect->sct_y, sect->sct_own)));
	}
	benefit(newown, 1);
	break;
    case 'O':
	if (arg < 0)
	    return RET_SYN;
	oldown = (natid) errcheck(arg, MAXNOC-1);
	pr(fmt("Old owner of %s changed from %s (#%d) to %s (#%d).\n",
	       xyas(sect->sct_x, sect->sct_y, cnum),
	       cname(sect->sct_oldown),
	       sect->sct_oldown, cname(oldown), oldown));
	sect->sct_oldown = oldown;
	break;
    case 'e':
	new = errcheck(arg, 100);
	noise(sect, 1, "Efficiency", (int) sect->sct_effic, new);
	sect->sct_effic = (u_char) new;
	break;
    case 'm':
	new = errcheck(arg, sect_mob_max);
	noise(sect, 1, "Mobility", (int) sect->sct_mobil, new);
	sect->sct_mobil = (u_char) new;
	break;
    case 'i':
	new = errcheck(arg, 100);
	noise(sect, 1, "Iron ore content", (int) sect->sct_min, new);
	sect->sct_min = (u_char) new;
	break;
    case 'b':
	new = errcheck(arg, 255);
	noise(sect, 1, "Bunker capacity", (int) sect->sct_harden, new);
	sect->sct_harden = (u_char) new;
	break;
    case 'g':
	new = errcheck(arg, 100);
	noise(sect, 1, "Gold content", (int) sect->sct_gmin, new);
	sect->sct_gmin = (u_char) new;
	break;
    case 'f':
	new = errcheck(arg, 120);
	noise(sect, 1, "Fertility", (int) sect->sct_fertil, new);
	sect->sct_fertil = (u_char) new;
	break;
    case 'c':
	new = errcheck(arg, 100);
	noise(sect, 1, "Oil content", (int) sect->sct_oil, new);
	sect->sct_oil = (u_char) new;
	break;
    case 'u':
	new = errcheck(arg, 100);
	noise(sect, 1, "Uranium content", (int) sect->sct_uran, new);
	sect->sct_uran = (u_char) new;
	break;
    case 'w':
	new = errcheck(arg, 100);
	noise(sect, 1, "Workforce percentage",
	      (int) sect->sct_work, new);
	sect->sct_work = (u_char) new;
	break;
    case 'l':
	new = errcheck(arg, 100);
	pr(fmt("Loyalty of %s changed from %d to %d%%\n",
	       xyas(sect->sct_x, sect->sct_y, cnum),
	       sect->sct_loyal, new));
	sect->sct_loyal = (u_char) new;
	break;
    case 'x':
	old = getvar(V_CHE, (char *)sect, EF_SECTOR);
	new = errcheck(arg, 65536);
	pr(fmt("Guerillas in %s changed from %d to %d%\n",
	       xyas(sect->sct_x, sect->sct_y, cnum), old, new));
	putvar(V_CHE, new, (char *)sect, EF_SECTOR);
	break;
    case 'p':
	old = getvar(V_PSTAGE, (char *)sect, EF_SECTOR);
	new = errcheck(arg, PLG_EXPOSED);
	pr(fmt("Plague stage of %s changed from %d to %d%\n",
	       xyas(sect->sct_x, sect->sct_y, cnum), old, new));
	putvar(V_PSTAGE, new, (char *)sect, EF_SECTOR);
	break;
    case 't':
	old = getvar(V_PTIME, (char *)sect, EF_SECTOR);
	new = errcheck(arg, 64);
	pr(fmt("Plague time of %s changed from %d to %d%\n",
	       xyas(sect->sct_x, sect->sct_y, cnum), old, new));
	putvar(V_PTIME, new, (char *)sect, EF_SECTOR);
	break;
    case 'a':
	new = errcheck(arg, 999);
	noise(sect, 1, "Available workforce", (int) sect->sct_avail,
	      new);
	sect->sct_avail = new;
	break;
    default:
	pr(fmt("huh? (%c)\n",op));
	return RET_SYN;
    }
    return RET_OK;
}



docountry(op, arg, p, farg, nat, np)
char	op;
int	arg;
char	*p;
float	farg;
natid	nat;
struct	natstr *np;
{
    coord	newx, newy;
    switch (op) {
    case 'n':
	pr(fmt("Country name changed from %s to %s\n",
	       np->nat_cnam, p));
	NAT_SET(nat_cnam[0], nat, p);
	break;
    case 'r':
	pr(fmt("Country representative changed from %s to %s\n",
	       np->nat_pnam, p));
	NAT_SET(nat_pnam[0], nat, p);
	break;
    case 'b':
	arg = errcheck(arg, max_btus);
	pr(fmt("BTU's changed from %d to %d\n", np->nat_btu, arg));
	NAT_SET(nat_btu, nat, arg);
	break;
    case 'm':
	benefit(nat, np->nat_reserve < arg);
	pr(fmt("Military Reserves changed from %d to %d\n",
	       np->nat_reserve, arg));
	if (np->nat_stat == STAT_NORM)
	    wu(0, nat,
	       fmt("Military Reserves changed from %d to %d by divine intervention.\n", 
		   np->nat_reserve, arg));
	NAT_SET(nat_reserve, nat, arg);
	break;
    case 'c':
	if (!sarg_xy(p, &newx, &newy))
	    return RET_SYN;
	pr(fmt("Capitol coordinates changed from %s to %s\n",
	       xyas(np->nat_xcap, np->nat_ycap, cnum),
	       xyas(newx, newy, cnum)));
	NAT_SET(nat_xcap, nat, newx);
	NAT_SET(nat_ycap, nat, newy);
	break;
    case 'o':
	if (!sarg_xy(p, &newx, &newy))
	    return RET_SYN;
	pr(fmt("Origin coordinates changed from %s to %s\n",
	       xyas(np->nat_xorg, np->nat_yorg, cnum),
	       xyas(newx, newy, cnum)));
	NAT_SET(nat_xorg, nat, newx);
	NAT_SET(nat_yorg, nat, newy);
	break;
    case 's':
	NAT_SET(nat_stat, nat, (char)errcheck(arg, STAT_NEW));
	break;
    case 'u':
	arg = errcheck(arg, m_m_p_d);
	pr(fmt("Number of minutes used changed from %d to %d.\n",
	       np->nat_minused, arg));
	NAT_SET(nat_minused, nat, arg);
	break;
    case 'L':
	arg = arg ? 1 : 0;
	pr(fmt("Login state changed from %d to %d.\n",
	       np->nat_login, arg));
	NAT_SET(nat_login, nat, arg);
	break;
    case 'M':
	pr(fmt("Money changed from %d to %d\n",np->nat_money, arg));
	wu(0, nat,
	   fmt("Money changed from %d to %d by divine intervention.\n",
	       np->nat_money, arg));
	NAT_SET(nat_money, nat, arg);
	break;
    case 'T':
	pr(fmt("Tech changed from %.2f to %.2f.\n",
	       np->nat_level[NAT_TLEV], farg));
	NAT_SETARY(nat_level[0], nat, NAT_TLEV, farg);
	break;
    case 'R':
	pr(fmt("Research changed from %.2f to %.2f.\n",
	       np->nat_level[NAT_RLEV], farg));
	NAT_SETARY(nat_level[0], nat, NAT_RLEV, farg);
	break;
    case 'E':
	pr(fmt("Education changed from %.2f to %.2f.\n",
	       np->nat_level[NAT_ELEV], farg));
	NAT_SETARY(nat_level[0], nat, NAT_ELEV, farg);
	break;
    case 'H':
	pr(fmt("Happiness changed from %.2f to %.2f.\n",
	       np->nat_level[NAT_HLEV], farg));
	NAT_SETARY(nat_level[0], nat, NAT_HLEV, farg);
	break;
    default:
	pr(fmt("huh? (%c)\n",op));
	break;
    }
    return RET_OK;
}


doship(op, arg, p, ship)
char	op;
int	arg;
char	*p;
struct	shpstr *ship;
{
    coord	newx, newy;
    
    newx = newy = 0;
    switch (op) {
    case 'I':
	ship->shp_uid = arg;
	break;
    case 'O':
	if (ship->shp_own)
	    wu(0, ship->shp_own,
	       fmt("%s #%d taken from you by deity intervention!\n",
		   mchr[ship->shp_type].m_name, ship->shp_uid));
	if (arg && arg < MAXNOC) {
	    wu(0, (natid)arg,
	       fmt("%s #%d given to you by deity intervention!\n",
		   mchr[ship->shp_type].m_name, ship->shp_uid));
	    ship->shp_own = (natid) arg;
	} else if (!arg) {
	    ship->shp_effic = 0;
	    ship->shp_own = (natid) 0;
	}
	break;
    case 'L':
	if (!sarg_xy(p, &newx, &newy))
	    return RET_SYN;
	ship->shp_x = newx;
	ship->shp_y = newy;
	break;
    case 'A':
	ship->shp_aboard = arg;
	break;
    case 'T':
	ship->shp_tech = arg;
	break;
    case 'E':
	ship->shp_effic = errcheck(arg, 100);
	if (arg < 10) {
	    ship->shp_effic = 0;
	    ship->shp_own = (natid) 0;
	}
	break;
    case 'M':
	ship->shp_mobil = restrict(-128,arg,ship_mob_max);
	break;
    case 'C':
	if (p[0] == '~') ship->shp_convoy = ' ';
	else if (isalpha(p[0])) ship->shp_convoy = p[0];
	else {
	    pr(fmt("%c: invalid convoy\n",p[0]));
	    return RET_FAIL;
	}
	break;
    case 'F':
	if (p[0] == '~') ship->shp_fleet = ' ';
	else if (isalpha(p[0])) ship->shp_fleet = p[0];
	else {
	    pr(fmt("%c: invalid fleet\n",p[0]));
	    return RET_FAIL;
	}
	break;
    case 'N':
	ship->shp_ntank = errcheck(arg,100);
	break;
    case 'D':
	ship->shp_depth = errcheck(arg,2);
	break;
    case 'X':
	ship->shp_air = errcheck(arg,mchr[ship->shp_type].m_maxair);
	break;
    case 'P':
	ship->shp_nplane = errcheck(arg, 100);
	break;
    case 'c':
	if (!putvar(V_CIVIL, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'm':
	if (!putvar(V_MILIT, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'u':
	if (!putvar(V_UW, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'f':
	if (!putvar(V_FOOD, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 's':
	if (!putvar(V_SHELL, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'g':
	if (!putvar(V_GUN, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'p':
	if (!putvar(V_PETROL, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'i':
	if (!putvar(V_IRON, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'd':
	if (!putvar(V_DUST, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'o':
	if (!putvar(V_OIL, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'l':
	if (!putvar(V_LCM, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'h':
	if (!putvar(V_HCM, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    case 'r':
	if (!putvar(V_RAD, arg, (char *)ship, EF_SHIP)) {
	    pr("No room on ship!\n");
	    return RET_FAIL;
	}
	break;
    default:
	pr(fmt("huh? (%c)\n",op));
	return RET_FAIL;
    }
    return RET_OK;
}


doplane(op, arg, p, plane)
    char	op;
    int	arg;
    char	*p;
    struct	plnstr *plane;
{
    coord	newx, newy;
    
    pr(fmt("arg = %d\n",arg));
    switch (op) {
    case 'l':
	if (!sarg_xy(p, &newx, &newy))
	    return RET_SYN;
	plane->pln_x = newx;
	plane->pln_y = newy;
	break;
    case 'o':
	if (plane->pln_own)
	    wu(0, plane->pln_own,
	       fmt("%s #%d taken from you by deity intervention!\n",
		   plchr[plane->pln_type].pl_name, plane->pln_uid));
	if (arg && arg < MAXNOC) {
	    plane->pln_own = (natid) arg;
	    wu(0, plane->pln_own,
	       fmt("%s #%d given to you by deity intervention!\n",
		   plchr[plane->pln_type].pl_name, plane->pln_uid));
	} else if (!arg) {
	    plane->pln_effic = 0;
	    plane->pln_own = (natid) 0;
	}
	break;
    case 'e':
	plane->pln_effic = errcheck(arg, 100);
	if (arg < 10) {
	    plane->pln_effic = 0;
	    plane->pln_own = (natid) 0;
	}
	break;
    case 'm':
	plane->pln_mobil = restrict(-128,arg,plane_mob_max);
	break;
    case 't':
	plane->pln_tech = arg;
	break;
    case 'w':
	if (p[0] == '~')
	    plane->pln_wing = ' ';
	else if (isalpha(p[0]))
	    plane->pln_wing = p[0];
	else {
	    pr(fmt("%c: invalid wing\n",p[0]));
	    return RET_FAIL;
	}
	break;
    case 'a':
	plane->pln_att = (char) errcheck(arg, 127);
	break;
    case 'd':
	plane->pln_def = (char) errcheck(arg, 127);
	break;
    case 'r':
	plane->pln_range = (u_char) arg;
	break;
    case 's':
	plane->pln_ship = restrict(-1,arg,32767);
	break;
    default:
	pr(fmt("huh? (%c)\n",op));
	return RET_FAIL;
    }
    return RET_OK;
}

dospy(op, arg, p, spy)
char op,*p;
int arg;
struct spystr *spy;
{
    coord	newx, newy;
    
    switch (op) {
    case 'o':
	if (spy->spy_own)
	    wu(0, spy->spy_own,
	       fmt("%s #%d taken from you by deity intervention!\n",
		   spchr[spy->spy_type].sp_name, spy->spy_uid));
	if (arg && arg < MAXNOC) {
	    spy->spy_own = (natid) arg;
	    wu(0, spy->spy_own,
	       fmt("%s #%d given to you by deity intervention!\n",
		   spchr[spy->spy_type].sp_name, spy->spy_uid));
	} else if (!arg) {
	    spy->spy_effic = 0;
	    spy->spy_own = (natid) 0;
	}
	break;
    case 'O':
	if (arg>=0 && arg<MAXNOC) spy->spy_oldown = arg;
	break;
    case 'l':
	if (!sarg_xy(p, &newx, &newy)) return RET_SYN;
	spy->spy_x = newx;
	spy->spy_y = newy;
	break;
    case 'e':
	spy->spy_effic = errcheck(arg, 100);
	if (arg < 10) {
	    spy->spy_effic = 0;
	    spy->spy_own = (natid) 0;
	}
	break;
    case 'p':   spy->spy_plntech = errcheck(arg,32767); break;
    case 's':	spy->spy_ship = restrict(-1,arg,32767);	break;
    case 'm':	spy->spy_mobil= restrict(-128,arg,spy_mob_max); break;
    case 'T':	spy->spy_tech = errcheck(arg,32767); break;
    case 'A':	spy->spy_age  = errcheck(arg,32767); break;
    case 'E':	spy->spy_edu  = errcheck(arg,32767); break;
    case 'H':	spy->spy_hap  = errcheck(arg,32767); break;
    default:
	pr(fmt("huh? (%c)\n",op));
	return RET_FAIL;
    }
    return RET_OK;
}
