static char *RCSid = "$Header: recvclient.c,v 1.1 89/12/14 13:26:42 jay Exp $";

/*
 * sendclient.c
 *
 * send and recieve commands
 *
 * Dave Pare, 1986
 */

#include <stdio.h>
#include "misc.h"
#include <errno.h>

int	aborted;

int recvclient(cmd, size)
char	*cmd;
int	size;
{
    extern	int errno;
    char	*p;
    
    if (aborted) return -1; 
    *cmd = 0;
    errno = 0;
    fflush(stdout);
    if (!fgets(cmd, size-1, stdin)) {
	clearerr(stdin);
	return 0;
    }
    if (feof(stdin)) return 0;
    cmd[size-1] = 0;
    p = index(cmd, '\0');
    if (p > cmd) {
	p--;
	if (*p == '\n' || *p == '\r') *p = 0;
	else if (!p) {
	    pr("Line too long; try again\n");
	    return 0;
	}
    }
    *p = 0;
    if (!strcmp(cmd, "ctld")) return 0;
    if (!strcmp(cmd, "aborted")) {
	aborted = 1;
	return -1;
    }
    return 1;
}
