#ifndef lint
static char *RCSid = "$Header: sect.c,v 1.1 89/12/14 13:28:36 jay Exp $";
#endif

/*
 * sect.c
 *
 * post-read and pre-write sector data massage
 *
 * Dave Pare, 1989
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "xy.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"
#include "plane.h"
#include "ship.h"

int sct_postread(id, ptr)
int id;
char *ptr;
{
    struct sctstr *sp = (struct sctstr *) ptr;
    owner = (god || sp->sct_own == cnum);
    return 1;
}

int sct_prewrite(id, ptr)
int id;
char *ptr;
{
    register struct sctstr *sp = (struct sctstr *) ptr;
    int	mines;
    if (sp->sct_type == SCT_BSPAN && sp->sct_effic < 20)
	collapse(sp);
    if (sp->sct_own != 0 && !getvar(V_CIVIL, ptr, EF_SECTOR) &&
	!getvar(V_MILIT, ptr, EF_SECTOR)) {
	/* more cruft! */
	if (sp->sct_type == SCT_CAPIT)
	    caploss(sp, sp->sct_own, "");
	sp->sct_own = 0;
	sp->sct_oldown = 0;
    }
    return 1;
}

int sinkstuff(bp)
struct sctstr *bp;
{
    int n;
    char *p;
    struct nstr_item ni;
    struct plnstr plane;
    struct shpstr ship,transport;
    struct mchrstr *mcp;
    struct plchrstr *pcp;

    if (bp->sct_type != SCT_WATER) return;

    /* Destroy any tanks and trains parked here */
    if (snxtitem(&ni, EF_SHIP, "*"))
	while (nxtitem(&ni, (char *)&ship)) {
	    if (!ship.shp_own) continue;
	    if (ship.shp_x != bp->sct_x || ship.shp_y != bp->sct_y) 
		continue;
	    if (!istank(&ship) && !istrain(&ship)) continue;
	    if (ship.shp_aboard >= 0) {
		if (getship(ship.shp_aboard,&transport))
		    if (!istank(&transport) && !istrain(&transport)) 
			continue;
	    }
	    ship.shp_effic = 0;
	    putship(ni.cur,&ship);
	}

    /* Destroy any planes parked here */
    if (snxtitem(&ni, EF_PLANE, "*"))
	while (nxtitem(&ni, (char *)&plane)) {
	    if (!plane.pln_own) continue;
	    if (plane.pln_x != bp->sct_x || plane.pln_y != bp->sct_y) 
		continue;
	    if (plane.pln_ship >= 0) {
		if (getship(plane.pln_ship,&transport))
		    if (transport.shp_own) continue;
	    }
	    plane.pln_effic = 0;
	    putplane(ni.cur,&plane);
	}
}
